class Arbo {
  Page [] page = new Page[0];
  Lien [] lien = new Lien[0];
  int nLiens = 0;
  int nPages = 0;
  int profondeur = 0;
  String nomDossier = "";

  int xDecal = 0;
  int yDecal = 0;
  int xDecalZoom = 0;
  float zoom = 1;

  Arbo() {
  }

  void setDossier(String s){
    nomDossier = s;
  }
  
  
  void savePosPages(String nomFichier) {
    String[] lines = new String[nPages];
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      lines[indexPage] = page[indexPage].xPos + "\t" + page[indexPage].yPos;
    }
    saveStrings(nomFichier, lines);
  }

  void loadPosPages(String nomFichier) {
    File f = new File(dataPath(nomFichier));
    if (f.exists())
    {
      String[] lines = loadStrings(nomFichier);
      if (nPages == lines.length) {
        for (int indexPage = 0; indexPage < nPages; indexPage++) {
          String[] list = split(lines[indexPage], "\t");
          page[indexPage].xPos = int(list[0]);
          page[indexPage].yPos = int(list[1]);
        }
      }
    }
    else{
      calcPosPages();
      savePosPages(nomFichier);
    }
  }

  void majPagesLiens(String nomFichier) {
    JSONArray tabPages;
    tabPages = loadJSONArray(nomFichier);
    nPages = tabPages.size();
    page = new Page[nPages];
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      JSONObject jsonPage = tabPages.getJSONObject(indexPage);
      page[indexPage] = new Page(indexPage, jsonPage.getString("nom"));
    }
    majLiens(nomFichier);
    saveJSONArray(tabPages,"temp.json");
  }

  void majLiens(String nomFichier){
    JSONArray tabPages;
    tabPages = loadJSONArray(nomFichier);
    nPages = tabPages.size();
    nLiens = 0;
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      JSONObject jsonPage = tabPages.getJSONObject(indexPage);
      JSONArray tabNav = jsonPage.getJSONArray("nav");
      for (int indexNav = 0; indexNav < tabNav.size(); indexNav++) {
        JSONObject nav = tabNav.getJSONObject(indexNav);
        String nomNav = nav.getString("nom");
        if (getPageId(nomNav)>=0) nLiens++;
      }
    }
    lien = new Lien[nLiens];
    int indexLien = 0;
    for (int indexPage = 0; indexPage < tabPages.size(); indexPage++) {
      JSONObject jsonPage = tabPages.getJSONObject(indexPage);
      JSONArray tabNav = jsonPage.getJSONArray("nav");
      for (int indexNav = 0; indexNav < tabNav.size(); indexNav++) {
        JSONObject nav = tabNav.getJSONObject(indexNav);
        String nomNav = nav.getString("nom");
        JSONArray tabClavier = nav.getJSONArray("clavier");
        String[] tabClavierString = tabClavier.getStringArray();
        String clavierAff = "";
        for (int indexClavier = 0; indexClavier < tabClavierString.length; indexClavier++) {
          clavierAff += tabClavierString[indexClavier];
          if (indexClavier<(tabClavierString.length-1)) {
            clavierAff += " + ";
          }
        }
        if (getPageId(nomNav)>=0) {
          lien[indexLien] = new Lien(indexPage, getPageId(nomNav), clavierAff);
          indexLien ++;
        }
      }
    }
  }
  
  boolean calcNiveauPages() {
    page[0].setNiveau(0);
    int n = 1;
    for (int i = 0; i<nLiens; i++) {
      if (lien[i].source == 0) {
        Page p = page[lien[i].destination];
        p.setNiveau(1);
        profondeur = 1;
        n++;
      }
    }
    for (int niveau = 1; niveau<20; niveau++) {
      for (int i = 0; i<nLiens; i++) {
        if (page[lien[i].source].niveau == niveau) {
          Page p = page[lien[i].destination];
          if (p.niveau == -1) {
            p.source = page[lien[i].source];
            p.setNiveau(niveau+1);
            profondeur = niveau+1;
            n++;
          }
        }
      }
    }
    if (n == nPages) {
      println("Niveau des pages toutes calculées");
      return true;
    } else {
      println("problème : certaine pages n'ont pas de niveau -- ",n,nPages);
      labelMsg.setText("Problème : Certaine pages n'ont pas de niveau");
      labelMsg.setVisible(true);
      return false;
    }
  }

  int getPageId(String nom) {
    int _id = -1;
    for (int indexPage = 0; indexPage < page.length; indexPage++) {
      if (nom.equals(page[indexPage].getNom())) {
        _id = indexPage;
      }
    }
    if (_id==-1) println("pas trouvé le nom de la page pour naviguer" + nom);
    return _id;
  }

  void calcPosPages() {
    int [] nPageNiveauEgal = new int[50];
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      Page p = page[indexPage];
      nPageNiveauEgal[p.niveau]++;
    }
    int[] indexPageNiveauEgal = new int [50];
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      Page p = page[indexPage];
      int xMin = (width-lMenu)/2 - (nPageNiveauEgal[p.niveau]/2)*(p.largeur+10);
      p.xPos = xMin + (p.largeur+10)*indexPageNiveauEgal[p.niveau];
      p.yPos = (p.hauteur+100)*p.niveau;
      indexPageNiveauEgal[p.niveau]++;
    }
  }

  void calcPosLiens() {
    for (int indexLien = 0; indexLien<nLiens; indexLien++) {
      Lien l = lien[indexLien];
      Page pS = page[l.source];
      Page pD = page[l.destination];
      if (pS.yPos<pD.yPos) {
        l.yS = pS.yPos+pS.hauteur;
        l.yD = pD.yPos;
      } else {
        l.yS = pS.yPos;
        l.yD = pD.yPos+pS.hauteur;
      }
      if (pS.niveau<pD.niveau) {
        l.xS = pS.xPos+pS.largeur/2;
        l.xD = pD.xPos+pD.largeur/2;
        l.couleur = color(255);
      } else {
        l.xS = pS.xPos+pS.largeur/2+5;
        l.xD = pD.xPos+pD.largeur/2+5;

        l.couleur = color(255, 0, 0, 160);
        l.retour = true;
      }
    }
  }

  void affArbo() {
    fill(0);
    noStroke();
    rect(0, 0, width, height);
    stroke(255);
    strokeWeight(2);
    textAlign(LEFT, BOTTOM);
    pushMatrix();
    translate(xDecal+lMenu+xDecalZoom, yDecal);
    scale(zoom);
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      Page p = page[indexPage];
      if(p.getSurbrillance()) fill(100,0,0);
      else fill(0);
      rect(p.xPos, p.yPos, p.largeur, p.hauteur);
      fill(255);
      text(p.nom, p.xPos+5, p.yPos + 20);
    }
    for (int indexPage = 0; indexPage < nPages; indexPage++) {
      Page p = page[indexPage];
      if (p.select) {
        fill(150, 0, 0);
        rect(p.xPos, p.yPos, p.largeur, p.hauteur);
        fill(255);
        text(p.nom, p.xPos+5, p.yPos + 20);
      }
    }
    textAlign(CENTER, CENTER);
    for (int indexLien = 0; indexLien<nLiens; indexLien++) {
      Lien l = lien[indexLien];
      l.textAff();
    }
    popMatrix();
  }


  void addPage(String _nom, String _nomSource) {
    // créé la nouvelle page _nom
    JSONArray tabPages;
    tabPages = loadJSONArray("temp.json");
    nPages = tabPages.size();
    JSONObject newPage = new JSONObject();
    newPage.setString("echo", "false");
    newPage.setString("chat", "false");
    newPage.setString("nom", _nom);
    JSONArray nav = new JSONArray();
    newPage.setJSONArray("nav", nav);
    tabPages.setJSONObject(nPages, newPage);
    saveJSONArray(tabPages, "temp.json");
    // ajoute le lien dans la page source _nomSource
    addLien(_nomSource, _nom,true);
  }

  void addLien(String _nomPage, String _nomFille, boolean trier) {
    int idSource = getPageId(_nomPage);
    JSONArray tabPages = loadJSONArray("temp.json");
    JSONObject pageSource = tabPages.getJSONObject(idSource);
    JSONObject newPage = new JSONObject();
    newPage = pageSource;
    JSONArray tabNav = pageSource.getJSONArray("nav");
    JSONObject objNav = new JSONObject();
    objNav.setString("nom", _nomFille);
    JSONArray clav = new JSONArray();
    objNav.setJSONArray("clavier", clav);
    tabNav.setJSONObject(tabNav.size(), objNav);
    newPage.setJSONArray("nav", tabNav);
    tabPages.setJSONObject(idSource, newPage);
    saveJSONArray(tabPages, "temp.json");
    if(trier)majPagesLiens("temp.json");
    else majLiens("temp.json");
    calcNiveauPages();
    if(trier)calcPosPages();
    calcPosLiens();
    affArbo();
  }

  void supprimerLien(String _nomPage, String _nomFille) {
    int idSource = getPageId(_nomPage);
    JSONArray tabPages = loadJSONArray("temp.json");
    JSONObject pageSource = tabPages.getJSONObject(idSource);
    JSONArray tabNav = pageSource.getJSONArray("nav");
    for (int i = 0; i<tabNav.size(); i++) {
      if (tabNav.getJSONObject(i).getString("nom").equals(_nomFille)) {
        // on vérifie que l'on peut supprimer ce lien. Si c'est le seule qui va vers un niveau plus bas, ce n'est pas possible de le supprimer.
        int idDestination = getPageId(_nomFille);
        int nDestination = page[idDestination].niveau;
        int nSource = page[idSource].niveau;
        if (nDestination>nSource) {
          int n = 0;
          for (int j = 0; j< arbo.nLiens; j++) {
            if (arbo.lien[j].source == idSource && arbo.lien[j].destination == idDestination) {
              n++;
            }
          }
          if (n>1) {
            tabNav.remove(i);
          } else {
            println("On ne peut pas virer ce lien");
            labelMsg.setText("Impossible de supprimer ce lien.");
            labelMsg.setVisible(true);
          }
        } else {
          tabNav.remove(i);
        }
      }
    }
    pageSource.setJSONArray("nav", tabNav);
    tabPages.setJSONObject(idSource, pageSource);
    saveJSONArray(tabPages, "temp.json");
    majLiens("temp.json");
    calcPosLiens();
    affArbo();
  }

  void nouveau() {
    JSONArray tabPages = new JSONArray();
    JSONObject newPage = new JSONObject();
    newPage.setString("echo", "false");
    newPage.setString("chat", "false");
    newPage.setString("nom", "accueil");
    JSONArray nav = new JSONArray();
    newPage.setJSONArray("nav", nav);
    tabPages.setJSONObject(0, newPage);
    saveJSONArray(tabPages, "temp.json");
    majPagesLiens("temp.json");
    calcNiveauPages();
    calcPosPages();
    calcPosLiens();
    savePosPages(sketchPath() + File.separator + "makerTemp.dat");
    affArbo();
  }

  void editLien(int idLien, String clavier) {
    lien[idLien].clavier = clavier;
    JSONArray tabPages = loadJSONArray("temp.json");
    JSONObject pageSource = tabPages.getJSONObject(lien[idLien].source);
    JSONArray tabNav = pageSource.getJSONArray("nav");
    for (int i = 0; i<tabNav.size(); i++) {
      if (page[lien[idLien].destination].getNom().equals(tabNav.getJSONObject(i).getString("nom"))) {
        clavier = trim(clavier);
        String[] sClav = split(clavier, " + ");
        JSONArray jsonClav = new JSONArray();
        for (int j = 0; j<sClav.length; j++) {
          jsonClav.setString(j, sClav[j]);
        }
        JSONObject objNav = tabNav.getJSONObject(i);
        objNav.setJSONArray("clavier", jsonClav);
      }
    }
    pageSource.setJSONArray("nav", tabNav);
    tabPages.setJSONObject(lien[idLien].source, pageSource);
    saveJSONArray(tabPages, "temp.json");
    calcPosLiens();
    affArbo();
  }

  void enregistrer(String nomDossier) {
    JSONArray tabPages = loadJSONArray("temp.json");
    saveJSONArray(tabPages, nomDossier + File.separator + "arborescence.json");
    savePosPages(nomDossier + File.separator + "maker.dat");
  }

  boolean supprimerPage(Page p) {
    boolean filles = false;
    JSONArray tabPages = loadJSONArray("temp.json");
    for (int i = 0; i< arbo.nLiens; i++) {
      if (lien[i].source == p.id && page[lien[i].destination].niveau>p.niveau) {
        filles = true;
      }
    }
    if (!filles) {
      tabPages.remove(p.id);
      // On supprime aussi tous les liens vers cette page
      for (int indexPage = 0; indexPage < tabPages.size(); indexPage++) {
        JSONObject jsonPage = tabPages.getJSONObject(indexPage);
        JSONArray tabNav = jsonPage.getJSONArray("nav");
        for (int indexNav = 0; indexNav < tabNav.size(); indexNav++) {
          JSONObject nav = tabNav.getJSONObject(indexNav);
          String nomNav = nav.getString("nom");
          if (nomNav.equals(p.getNom())) {
            tabNav.remove(indexNav);
            indexNav = 0;
          }
        }
      }
    } else {
      println("Hehe, pas possible, il y a des fifilles");
      labelMsg.setText("Impossible de supprimer une page qui a des filles.");
      labelMsg.setVisible(true);
    }
    saveJSONArray(tabPages, "temp.json");
    majPagesLiens("temp.json");
    calcNiveauPages();
    calcPosPages();
    calcPosLiens();
    savePosPages(sketchPath() + File.separator + "makerTemp.dat");
    affArbo();
    return !filles;
  }
}
