import g4p_controls.*;

GTextField txfNom;
GTextField[] txfLiens = new GTextField[50];
GLabel[] labels = new GLabel[50];
GLabel labelMsg;
GButton btnNewArbo, btnLoadArbo, btnSaveArbo, btnCreerFille, btnSupprimerPage, btnCreerLien, btnEditerLien, btnSupprimerLien, btnEcho;

Arbo arbo;
Page pSelect = null;
int lSource = -1;
boolean lSupp = false;
boolean updateAffArbo = false;

PVector mouseInvTrans = new PVector(0, 0);
int affWidth;
int lMenu = 200;

void setup() {
  size(1200, 900);
  initMenu();
  background(0);
  arbo = new Arbo();
  arbo.nouveau();
}

void draw() {
  stroke(200);
  strokeWeight(2);
  line(lMenu, 0, lMenu, height);
  fill(0);
  rect(0, 0, lMenu, height);
  mouseInvTrans = invTransformation(mouseX, mouseY);
  if (updateAffArbo) {
    updateAffArbo = false;
    arbo.affArbo();
  }
  if (lSource>-1 && pSelect.select) {
    arbo.affArbo();
    PVector posTrans = transformation(pSelect.xPos, pSelect.yPos);
    strokeWeight(5);
    if (!lSupp) {
      cursor(HAND);
      stroke(0, 255, 0);
      labelMsg.setText("Choisir destination du lien à créer");
    } else {
      cursor(CROSS);
      stroke(255, 0, 0);
      labelMsg.setText("Choisir destination du lien à supprimer");
    }

    labelMsg.setVisible(true);
    line(posTrans.x+arbo.zoom*pSelect.largeur/2, posTrans.y+arbo.zoom*pSelect.hauteur/2, mouseX, mouseY);
  } else {
    cursor(ARROW);
  }
  for (int indexPage = 0; indexPage < arbo.nPages; indexPage++) {
    Page p = arbo.page[indexPage];
    if (mouseInvTrans.x>p.xPos && mouseInvTrans.x<(p.xPos+p.largeur) && mouseInvTrans.y>p.yPos && mouseInvTrans.y<(p.yPos+p.hauteur)) {
      p.setSurbrillance(true);
    } else p.setSurbrillance(false);
  }
}

void mousePressed() {
  labelMsg.setVisible(false);
  for (int indexPage = 0; indexPage < arbo.nPages; indexPage++) {
    Page p = arbo.page[indexPage];
    if (mouseInvTrans.x>p.xPos && mouseInvTrans.x<(p.xPos+p.largeur) && mouseInvTrans.y>p.yPos && mouseInvTrans.y<(p.yPos+p.hauteur)) {
      p.select = true;
      pSelect = p;
      if (pSelect.getEcho()) {
        btnEcho.setText("echo off");
      } else btnEcho.setText("echo on");
    } else if (mouseX>lMenu) p.select=false;
  }

  if (lSource>-1 && pSelect.select) {
    if (!lSupp) {
      arbo.addLien(arbo.page[lSource].getNom(), pSelect.getNom(), false);
    } else {
      arbo.supprimerLien(arbo.page[lSource].getNom(), pSelect.getNom());
    }
    lSource = -1;
  }
  arbo.affArbo();
}

void mouseDragged() {
  if (mouseButton == LEFT && mouseX>lMenu) {
    for (int indexPage = 0; indexPage < arbo.nPages; indexPage++) {
      Page p = arbo.page[indexPage];
      if (p.select) {
        p.xPos = int(mouseInvTrans.x)-p.largeur/2;
        p.yPos = int(mouseInvTrans.y)-p.hauteur/2;
        arbo.savePosPages(sketchPath() + File.separator + "makerTemp.dat");
      }
    }
    arbo.calcPosLiens();
    updateAffArbo = true;
  }
}

void keyPressed() {
  if (key == CODED) {
    if (keyCode == UP) {
      arbo.yDecal = arbo.yDecal + 20;
    }
    if (keyCode == DOWN) {
      arbo.yDecal = arbo.yDecal - 20;
    }
    if (keyCode == LEFT) {
      arbo.xDecal = arbo.xDecal + 20;
    }
    if (keyCode == RIGHT) {
      arbo.xDecal = arbo.xDecal - 20;
    }
  }
  arbo.affArbo();
}

void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  arbo.zoom -= e*0.1;
  arbo.xDecalZoom = int((width/2)*(1-arbo.zoom));
  arbo.affArbo();
}


void arboSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    String s = selection.getAbsolutePath();
    String arbo = "arborescence.json";
    String fin = s.substring(s.length()-arbo.length());
    String localPath = s.substring(0, s.length()-arbo.length());
    println("chemin choisi = " + localPath);
    if (fin.equals(arbo)) {
      println("fichier arborescence.json présent");
      setDossier(localPath);
      updateAffArbo = true;
    }
  }
}

void setDossier(String s) {
  arbo.majPagesLiens(s+File.separator+"arborescence.json");
  arbo.calcNiveauPages();
  arbo.loadPosPages(s+File.separator+"maker.dat");
  arbo.calcPosLiens();
  arbo.affArbo();
}


void arboSauv(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    println("enregistré sous :" +selection.getAbsolutePath());
    arbo.enregistrer(selection.getAbsolutePath());
  }
}

PVector invTransformation(int _x, int _y) { // de ecran transformé par zoom et décalage vers écran d'origine sans transformation
  PVector vOut = new PVector(0, 0);
  vOut.x = int((_x-arbo.xDecal-arbo.xDecalZoom-lMenu)/arbo.zoom);
  vOut.y = int((_y-arbo.yDecal)/arbo.zoom);
  return vOut;
}

PVector transformation(int _x, int _y) {
  PVector vOut = new PVector(0, 0);
  vOut.x = int(arbo.zoom*_x+arbo.xDecal+arbo.xDecalZoom+lMenu);
  vOut.y = int(arbo.zoom*_y+arbo.yDecal);
  return vOut;
}
